#!/bin/sh

__move_old_userfpdir_to_XDG_CONFIG_HOME() {
    old_userfpdir="${HOME}/.freeplane"
    if [ -d "$old_userfpdir" -a ! -d "$userfpdir" ] ; then
	mv "$old_userfpdir" "$userfpdir"
    fi
}

userfpdir="${XDG_CONFIG_HOME:-$HOME/.config}/freeplane"
__move_old_userfpdir_to_XDG_CONFIG_HOME

# Source functions library
if [ ! -f /usr/share/java-utils/java-functions ] ; then 
    echo "Can't find functions library, aborting"
    exit 1
fi

. /usr/share/java-utils/java-functions
 
BASE_OPTIONS="-Xmx512m"
BASE_JARS="" # no use setting here, knopflerfish ignores $CLASSPATH

# Set parameters
set_flags $BASE_FLAGS
set_options $BASE_OPTIONS

knopflerfishdir="/usr/share/java/freeplane"
freejavadir="/usr/share/java/freeplane"
freedatadir="/usr/share/freeplane"

defines=-Dgnu.java.awt.peer.gtk.Graphics=Graphics2D

set_javacmd
exec "${JAVACMD}" $FLAGS $BASE_OPTIONS \
 "-Dorg.freeplane.param1=$1"\
 "-Dorg.freeplane.param2=$2"\
 "-Dorg.freeplane.param3=$3"\
 "-Dorg.freeplane.param4=$4"\
 "-Dorg.freeplane.param5=$5"\
 "-Dorg.freeplane.param6=$6"\
 "-Dorg.freeplane.param7=$7"\
 "-Dorg.freeplane.param8=$8"\
 "-Dorg.freeplane.userfpdir=$userfpdir"\
 "-Dorg.knopflerfish.framework.bundlestorage=memory"\
 "-Dorg.freeplane.globalresourcedir=${freedatadir}/resources"\
 "-Dorg.knopflerfish.gosg.jars=reference:file:${freejavadir}"\
 $defines\
 -jar "${freejavadir}/framework.jar"\
 -xargs "${freedatadir}/props.xargs"\
 -xargs "${freedatadir}/init.xargs"
